<?php
	$max_pages = 10;					// The number of results to show per set when results span more than one page of results

	//***************
	// Set some globals for use in this and other jsearch pages
	// This assumes that your wordpress installation is at the root of your server. If not, change this variable
	$GLOBALS['jsearch_plugin_url'] = $jsearch_plugin_url = get_bloginfo('url').'/wp-content/plugins/jsearch/';
	$GLOBALS['jsearch_plugin_path'] = $jsearch_plugin_path = str_replace("\\","/",dirname(__FILE__));
	$GLOBALS['jsearch_relative_url'] = $jsearch_relative_url = str_replace(get_bloginfo("url")."/","",$jsearch_plugin_url);

	//***************
	// Set category variables for use with various Jsearch functions
	function jsearch_create_subcats_string($subcats)
	{
		$first = "";
		$to_return = "";
		foreach ($subcats as $a_cat)
		{
			$to_return .= $first.$a_cat->term_id;
			$first = ",";
		}
		return $to_return;
	}
	function jsearch_create_catlist($cats)
	{
		$to_return = array();
		foreach ($cats as $a_cat)
		{
			$to_return[$a_cat->term_id]['id'] = $a_cat->term_id; 
			$to_return[$a_cat->term_id]['name'] = $a_cat->name; 
			$to_return[$a_cat->term_id]['parent'] = $a_cat->parent; 
			$to_return[$a_cat->term_id]['subcats'] = jsearch_create_subcats_string(get_categories("parent=".$a_cat->term_id."&hide_empty=true&orderby=slug")); 
		}
		// Now that the list is complete
		foreach ($cats as $a_cat)
		{
			$depth = 0;
			$walker = $to_return[$a_cat->term_id];			// Set to current cat
			while ($walker['parent'] != 0)
			{
				$depth++;					// It's a level down
				$walker = $to_return[$walker['parent']];	// Now walk up the path
			}
			$to_return[$a_cat->term_id]['depth'] = $depth;
		}
		return $to_return;
	}		        		          
	$GLOBALS['jsearch_cats'] = $jsearch_cats = jsearch_create_catlist(get_categories("hide_empty=true&orderby=slug")); 
	$GLOBALS['jsearch_tags'] = $jsearch_tags = jsearch_create_catlist(get_tags("")); 

	$jsearch_options_defaults = array(
	'ppp'=>10,
	'hide_search_titles'=>0,
	'search_titles'=>1,
	'hide_search_content'=>0,
	'search_content'=>1,
	'hide_search_excerpts'=>0,
	'search_excerpts'=>1,
	'hide_search_comments'=>0,
	'search_comments'=>1,
	'hide_search_custom'=>0,
	'search_custom'=>1,
	'hide_ppall'=>1,
	'ppall'=>'both',
	'hide_tefull'=>0,
	'tefull'=>'title',
	'hide_ppp'=>0,
	'ppp'=>10,
	'hide_results_type'=>1,
	'results_type'=>'dual_list',
	'hide_date'=>0,
	'jsearch_hide_adder'=>1,
	'jsearch_hide_added'=>0,
	'jsearch_hide_options'=>1,
	);


	//********************************
	// Helper functions first
	//********************************

	// Just writes a button. Only here to save us writing a lot of code
	function jsearch_button($id,$value,$classes='')
	{
		echo "<div class='jsearch_button $classes' id=$id>$value</div>";
	}
	
	// Gets a variable checking request then options then setting a default
	function jsearch_get_var($which)
	{
		global $jsearch_options_defaults;
	
		$options = jsearch_get_options();
		$to_return = $_REQUEST[$which];
		if (!isset($to_return)) $to_return = $options[$which];
		if (!isset($to_return)) $to_return = $jsearch_options_defaults[$which];
		return $to_return;
	}

	// Function to drop some url vars to Javascript
	function jsearch_drop_vars($which)
	{
		echo "var ".$which."_any = [];\n";	// Holds the added terms
		echo "var ".$which."_all = [];\n";	// Holds the added terms
		echo "var ".$which."_none = [];\n";	// Holds the added terms
		$aan_arr = Array("any","all","none");	// Just for efficency
		foreach ($aan_arr as $aan)
		{
			if ($url_var = $_GET[$which."_".$aan])		// If they passed this in the url, grab it
			{
				$vars = explode(",",$url_var);		// Make it into an array
				$var_count = 0;
				foreach ($vars as $a_var)
				{
					echo $which."_".$aan."[".$var_count."] = \"$a_var\";\n"; 
					$var_count++;
				}
			}
		}
	}
	
	// Drops all categories to javascript to support various category selection functions
	function jsearch_drop_cats()
	{
		global $jsearch_cats;
		
		$cat_count = 0;
		$p_count = 0;
		foreach ($jsearch_cats as $a_cat)
		{
			echo "jsearchCats[".$cat_count."] = new Object();\n";
			echo "jsearchCats[".$cat_count."][\"id\"] = \"".$a_cat['id']."\";\n";
			echo "jsearchCats[".$cat_count."][\"name\"] = \"".$a_cat['name']."\";\n";
			echo "jsearchCats[".$cat_count."][\"parent\"] = \"".$a_cat['parent']."\";\n";
			echo "jsearchCats[".$cat_count."][\"depth\"] = \"".$a_cat['depth']."\";;\n";
			if (strlen($a_cat['subcats']))	// if there are any subcategories
			{
				$temp = str_replace(",","','",$a_cat['subcats']);
				echo "jsearchCats[".$cat_count."][\"subcats\"] = ['".$temp."'];\n"; // A list of ids for any subcategories
				echo "jsearchCatParents[$p_count] = \"".$a_cat['id']."\";\n";
				$p_count++;
			}
			else 
				echo "jsearchCats[".$cat_count."][\"subcats\"] = '';\n"; // A list of ids for any subcategories
			echo "jsearchCatIndexes[\"".$a_cat['id']."\"] = \"".$cat_count."\";\n";
			$cat_count++;
		}		
	}

	// Adds a url variable. Checks to see if they already have some and adds it appropriately
	function jsearch_add_url_var($url,$var)
	{
		if (strpos($url,"?") !== false)
			return $url . "&".$var;
		else
			return $url . "?".$var;
	}

	// Helper function. Shows a question mark 
	// $pop is the text to pop up and $side is whether it should pop to the left or right of the calling object
	function jsearch_question_pop($pop)
	{
		$to_return  = "<img class='jsearch_question_mark' onmouseover=\"jsearchPopHelp(this,'$pop')\" onmouseout=jsearchPopHelpOff() src='".$GLOBALS['jsearch_plugin_url']."/jsearch_q.gif' />";
		return $to_return;
	}	

	// Because our current page can be in several different formats, abstract out the code that finds out where we are
	function jsearch_get_paged()
	{
		if (!$paged = jsearch_filter_allowed($_REQUEST['paged'],"0-9")) 
		{
			if (strpos($url = $_SERVER["REQUEST_URI"],"/page/") !== false)
			{
				$get_page = explode("/page/",$url);
				$get_page = explode("?",$get_page[1]);
				$paged = $get_page[0];
			}
			if (!$paged)
				$paged = 1;
		}
		return $paged;
	}

	// Helper function (got tired of typing it)
	function jsearch_cleaner($input)
	{
		return strip_tags(stripslashes($input));
	}
	
	// ******* OBSOLETE ********
	// Strips all but the allowed characters
	function jsearch_reg_filter($input,$allowed)
	{
		return preg_replace("/[^".$allowed."]/i","",$input);
	}

	// Strips all but the allowed characters
	function jsearch_filter_allowed($input,$allowed)
	{
		return preg_replace("/[^".$allowed."]/i","",$input);
	}

	// Strips all but the allowed characters
	function jsearch_filter_denied($input,$denied)
	{
		return $input;
		return preg_replace("/[".$denied."]/i","",$input);
	}

	// Writes out the search in english to help people understand why they didn't get any results
	// Pass a jquery object which will contain all the data we need.
	function jsearch_no_results($jsearch)
	{?>
		<h2>No Results</h2>
		<p>Wha? Hey! Why isn't there anything here?</p>
		<p>It turn out that I couldn't find anything with the parameters you used. Let me try describing the search you made in plain English as I understood it:</p>
		
		<div id=jsearch_english></div>
		
		<p>Was that what you meant? If not, try changing the search and see if that helps.</p>

		<script language=javascript>
		jsearchUpdateEnglish();
		</script>
	<?php
	}

	// Helper function. Not only makes for less code, but creates standardization through code abstraction
	function jsearch_write_yes_no_selector($label, $name, $checked)
	{
		global $wpdb;
		
		if ((int) $checked == 1) $yes_checked = "selected";
		else $no_checked = "selected";
		echo '<p style="text-align:right;"><label for="'.$name.'">'.$label.':'. 
		' <select id="'.$name.'" name="'.$name.'">'.
		' <option value=1 '.$yes_checked.'>Yes</option>'.
		' <option value=0 '.$no_checked.'>No</option>'.
		'</label></select></p>';
	}

	class jsearch_query {
	
		var $jquery;				// Holds the generic query that will be split into a page and post query
		var $options;				// Holds any search related options that are passed.

		var $page_query;			// Holds the actual query used to get pages
		var $page_query_count;			// Holds an alternate query that will get the total number of results only
		var $page_results;			// The results
		var $page_results_count;		// The number of results
		var $page_results_pages;		// The number of pages based on the "posts per page" divided into the number of results

		var $post_query;			// 
		var $post_query_count;			// 
		var $post_results;			// 
		var $post_results_count;		// 
		var $post_results_pages;		// 

		var $both_query;			// 
		var $both_query_count;			// 
		var $both_results;			
		var $both_results_count;		
		var $both_results_pages;		

		var $term_any;	
		var $term_all;
		var $term_none;
		var $cat_any;	
		var $cat_all;
		var $cat_none;
		var $tag_any;
		var $tag_all;
		var $tag_none;	
		var $sdate;				// Date range restricters
		var $edate;				// Date range restricters

		// Saves us a lot of writing, but that's about it.
		function terms_query_builder($term,$andor="OR",$not="")
		{			
			global $wpdb;
				
			$to_return = "";
			$first = "";
			if ($this->options['search_titles'])
			{
				$to_return .= " $first LOWER(post_title) $not LIKE '%$term%'";
				if (!$first) $first = $andor;
			}
			if ($this->options['search_content'])
			{
				$to_return .= " $first LOWER(post_content) $not LIKE '%$term%'";
				if (!$first) $first = $andor;
			}
			if ($this->options['search_excerpts'])
			{
				$to_return .= " $first LOWER(post_excerpt) $not LIKE '%$term%'";
				if (!$first) $first = $andor;
			}
			if ($this->options['search_custom'])
			{
				$to_return .= " $first ID $not IN (SELECT post_id FROM ".$wpdb->postmeta." WHERE post_id = ID AND meta_value LIKE '%$term%')";
				if (!$first) $first = $andor;
			}	
			if ($this->options['search_comments'])
			{
				$to_return .= " $first ID $not IN (SELECT comment_post_id FROM ".$wpdb->comments." WHERE comment_post_id = ID AND comment_content LIKE '%$term%')";
				if (!$first) $first = $andor;
			}	
			return $to_return;
		}
		
		// Adds a category or tag portion of an SQL query
		function cattag_adder($cattag,$aan,$value)
		{
			global $wpdb;
			
			if (!$value) return;		// If there's no value, why be here?
			if ($cattag == "cat")
				$which = "category";
			else
				$which = "post_tag";
				
			$to_return = "";
			
			if ($aan == "any")
			{
				// In this case, they must ALL be there so surround it in ( ) so that it's an all or none portion of the true-false string
				$to_return = " AND (";
				$vals = explode(",",$value);
				$first = "";
				foreach ($vals as $val)
				{
					$to_return .= $first." ID IN (SELECT object_id FROM $wpdb->term_taxonomy as T "
					." INNER JOIN $wpdb->term_relationships as R ON (T.term_taxonomy_id = R.term_taxonomy_id) WHERE "
					." taxonomy = '$which' AND term_id = '$val' )";
					$first = " OR ";
				}
				$to_return .= ")";
			}
			else
			{
				if ($aan == "none")
					$not = " NOT ";
				$vals = explode(",",$value);
				foreach ($vals as $val)
				{
					$to_return .= " AND ID $not IN (SELECT object_id FROM $wpdb->term_taxonomy as T "
					." INNER JOIN $wpdb->term_relationships as R ON (T.term_taxonomy_id = R.term_taxonomy_id) WHERE "
					." taxonomy = '$which' AND term_id = '$val' )";
				}
				
			}
			
			return $to_return;
		}

		function build_query()
		{		
			global $wp_query;
			global $wpdb;
									
			$get_keys = array_keys($_REQUEST);
			$get_vals = array_values($_REQUEST);
			$for_count = count($_REQUEST);
			for ($i=0; $i < $for_count; ++$i)
			{
				$_REQUEST[$get_keys[$i]] = attribute_escape($get_vals[$i]);		// A bit of security to make sure people aren't passing code
			}

			// Grab all the options						
			$this->options = array();							// What options are set

			$this->options['search_titles'] = jsearch_get_var('search_titles');
			$this->options['search_content'] = jsearch_get_var('search_content');
			$this->options['search_excerpts'] = jsearch_get_var('search_excerpts');
			$this->options['search_comments'] = jsearch_get_var('search_comments');
			$this->options['search_custom'] = jsearch_get_var('search_custom');
			$this->options['tefull'] = jsearch_get_var('tefull');
			$this->options['ppall'] = jsearch_get_var('ppall');
									
			// Grab all the vars						
			$this->jquery = array();							// This variable will hold all the parameters that we'll search on

			if ($_REQUEST['term_any']) $this->term_any = explode(",",strtolower(jsearch_filter_denied($_REQUEST['term_any'],'"\\')));
			if ($_REQUEST['term_all']) $this->term_all = explode(",",strtolower(jsearch_filter_denied($_REQUEST['term_all'],'"\\')));
			if ($_REQUEST['term_none']) $this->term_none = explode(",",strtolower(jsearch_filter_denied($_REQUEST['term_none'],'"\\')));
			if (count($this->term_any) || count($this->term_all) || count($this->term_none))
				$jsearch_keywords = true;			// This variable used to simplify the query if they're not doing keyword search
			if (!($this->options['search_titles']||$this->options['search_content']||$this->options['search_excerpts']||$this->options['search_comments']||$this->options['search_custom']))
				$jsearch_keywords = false;			// Nothing is selected to be searched so turn off keyword search entirely

			$this->cat_any = jsearch_filter_allowed($_REQUEST['cat_any'],"0-9,");
			$this->cat_all = jsearch_filter_allowed($_REQUEST['cat_all'],"0-9,");
			$this->cat_none = jsearch_filter_allowed($_REQUEST['cat_none'],"0-9,");
			
			if ($this->tag_any = jsearch_filter_allowed($_REQUEST['tag_any'],"0-9,"))
				if (!strpos($this->tag_any,","))	$this->tag_any = $this->tag_any.",".$this->tag_any;		// Bug fix. Described on the codex. If there's only one tag, have to put another
			$this->tag_all = jsearch_filter_allowed($_REQUEST['tag_all'],"0-9,");
			$this->tag_none = jsearch_filter_allowed($_REQUEST['tag_none'],"0-9,");
								
			//**********************
			//**********************
			// Build a query to feed into the Query_posts function
			//**********************
			//**********************
		
		
			$this->jquery['ppp'] = jsearch_get_var('ppp');
			if (!$this->jquery['paged'] = jsearch_get_paged())
				$this->jquery['paged'] = 1;
		
			if (strtolower($_REQUEST['order']) == "asc")			// If they specifically chose ascending, then use that. In all other cases (Not set, DESC, or garbage), it's DESC
				$this->jquery['order'] = "asc";
			else if (strtolower($_REQUEST['order']) == "desc")
				$this->jquery['order'] = "desc";

			if ($temp_year = $_REQUEST['jsearch_sdate_year'])				// We're not going to guess on the year. If it's not set, don't bother searching
			{
				$temp_month = $_REQUEST['jsearch_sdate_month'];
				$temp_day = $_REQUEST['jsearch_sdate_day'];
				$this->jquery['sdate'] = $temp_year."-".(isset($temp_month)?$temp_month:"00")."-".(($temp_day)?$temp_day:"00")." 00:00:00";
			}
			if ($temp_year = $_REQUEST['jsearch_edate_year'])				// We're not going to guess on the year. If it's not set, don't bother searching
			{
				$temp_month = $_REQUEST['jsearch_edate_month'];
				$temp_day = $_REQUEST['jsearch_edate_day'];
				$this->jquery['edate'] = $temp_year."-".(isset($temp_month)?$temp_month:"00")."-".(($temp_day)?$temp_day:"00")." 00:00:00";
			}
							
			// **********************************************************
			// ************** / Do the term search stuff \ ****************
			if ($jsearch_keywords) 		// assuming there are any to deal with anyway
			{
				$term_query_any = "";
				$term_query_andnone = "";
								
				$first = "";						
				$term_query = "";
				// Any array is a bit tougher since we have to write them all out at once connected by ORs
				if (is_array($this->term_any))
				{
					$term_query .= " AND(";
					$first = "";
					foreach ($this->term_any as $term)
					{
						$term_query .= $first.$this->terms_query_builder($term);		// Add a term to the query
						if (!$first) $first = " OR ";
					}
					$term_query .= ")";
				}
				// Add any ALL words one after the other
				if (is_array($this->term_all))
					foreach ($this->term_all as $term)
					{
						$term_query .= " AND (";
						$term_query .= $this->terms_query_builder($term);
						$term_query .= ")";
					}
				// NOTs can just be added too
				if (is_array($this->term_none))
					foreach ($this->term_none as $term)
					{
						$term_query .= " AND (";
						$term_query .= $this->terms_query_builder($term," AND "," NOT ");
						$term_query .= ")";
					}

				$term_query = str_replace("AND (( AND(", " AND ((",$term_query);		// Dirty fix. Need to enclose the full Terms section in paren
				$term_query = str_replace("AND (( AND (", " AND ((",$term_query);		// Dirty fix. Need to enclose the full Terms section in paren
			}	

			// **************\ Do the term search stuff /***************
			// **********************************************************

			// Hey look! Categories!
			if ($this->cat_any || $this->cat_all || $this->cat_none)
			{
				$cat_query = "";
				$cat_query .= $this->cattag_adder("cat","any",$this->cat_any);
				$cat_query .= $this->cattag_adder("cat","all",$this->cat_all);
				$cat_query .= $this->cattag_adder("cat","none",$this->cat_none);		
			}

			// OH BOY! Tags!
			if ($this->tag_any || $this->tag_all || $this->tag_none)
			{
				$tag_query = "";
				$tag_query .= $this->cattag_adder("tag","any",$this->tag_any);
				$tag_query .= $this->cattag_adder("tag","all",$this->tag_all);
				$tag_query .= $this->cattag_adder("tag","none",$this->tag_none);		
			}
			
	
			// *******************************
			// QUERY COMPLETE
			// *******************************
			// Now store them in our object 
		
			$date = "";
			if ($this->jquery['sdate'])
				$date .= " AND post_date >= '".$this->jquery['sdate']."'";
			if ($this->jquery['edate'])
				$date .= " AND post_date <= '".$this->jquery['edate']."'";
			$count_query = "SELECT count(ID) FROM ".$wpdb->posts." WHERE post_status='publish' ".$date;
			$real_query = "SELECT * FROM ".$wpdb->posts." WHERE post_status='publish' ".$date;
			$start = ($this->jquery['paged']-1)*$this->jquery['ppp'];
			$end_query = "ORDER BY ".$wpdb->posts.".post_date ".$this->jquery['order']." LIMIT ".$start.",".$this->jquery['ppp'];

			$page = " AND ".$wpdb->posts.".post_type = 'page' ";
			$post = " AND ".$wpdb->posts.".post_type = 'post' ";

			$this->post_query_count = $count_query.$post.$term_query.$cat_query.$tag_query;
			$this->post_query = $real_query.$post.$term_query.$cat_query.$tag_query.$end_query;
			$this->page_query_count = $count_query.$page.$term_query.$cat_query.$tag_query;
			$this->page_query = $real_query.$page.$term_query.$cat_query.$tag_query.$end_query;
			$this->both_query_count = $count_query.$term_query.$cat_query.$tag_query;
			$this->both_query = $real_query.$term_query.$cat_query.$tag_query.$end_query;
		}	

	
		function get_results($which)
		{		
			global $wpdb;

			if ($which == "pages")
			{
				$this->page_results_count = $wpdb->get_var($this->page_query_count);
				$this->page_results_pages = ceil($this->page_results_count/$this->jquery['ppp']);
				$this->page_results = $wpdb->get_results($this->page_query);
			}
			if ($which == "posts")
			{
				$this->post_results_count = $wpdb->get_var($this->post_query_count);
				$this->post_results_pages = ceil($this->post_results_count/$this->jquery['ppp']);
				$this->post_results = $wpdb->get_results($this->post_query);
			}
			if ($which == "both")
			{
				$this->both_results_count = $wpdb->get_var($this->both_query_count);
				$this->both_results_pages = ceil($this->both_results_count/$this->jquery['ppp']);
				$this->both_results = $wpdb->get_results($this->both_query);
			}
		}

		// For printing a list of numbered links to multiple pages (if there are that many results)
		function page_links($which)
		{
			global $max_pages;
		
			$paged = $this->jquery['paged'];
			$links = "";
			if ($which == "post")
				$num_pages = $this->post_results_pages;
			if ($which == "page")
				$num_pages = $this->page_results_pages;
			if ($which == "both")
				$num_pages = $this->both_results_pages;
			if ($num_pages==1) return;	// No sense if there's a page or less of results
						
			$start = max(1,$paged-floor($max_pages/2));
			echo "<table class='jsearch_page_links_area'><tr>";
			if ($start > 1)
				echo "<td><input type=button class=jsearch_link_buttons onclick=\"jsearchGoto(".($paged-1).")\" value=\"Prev\" /></td><td>&nbsp;|&nbsp;</td>";
			echo "<td>";
			for ($i=$start;$i<$start+$max_pages;$i++)
			{
				if ($i > $num_pages)		// Don't go past the last one
					break;
				if ($links) 	// There's something there
					$links .= " | ";
				if ($i != $paged)
					$links .= "<a href=\"javascript:jsearchGoto($i)\">$i</a>";	// Hold the current page
				else
					$links .= "<b>$i</b>";
			}
			echo $links;
			echo "</td>";
			// Figure the values for the next buttons	
			$separator = "<td>&nbsp;|&nbsp;</td>";
			if ($start+$max_pages < $num_pages)
				echo $separator."<td><input type=button class=jsearch_link_buttons style='width:40px' onclick=\"jsearchGoto(".($paged+1).")\" value=\"Next\" /></td>";
			echo "</tr></table>";
		}
		
		// Nothing to do for constructor
		function jsearch_query()
		{
		}

	} // End jsearch query class
	
	
	//***********************
	// Jsearch print cats functions
	
		// Takes a var and tests for commas. If so, ARRAY!
	function jsearch_parse_var($var)
	{
		if (strpos($var,",")===false) return $var;
		return explode(",",$var);
	}
	
	// Takes a name=pair var and splits it into an associative array name=>value
	function jsearch_parse_pair($pair)
	{
		if (strpos($pair,"=")===false) return;
		$temp = explode("=",$pair);
		return array($temp[0] => jsearch_parse_var($temp[1]));		
	}
	
	// Takes a string like this and does something with it: var=value&var2=notherval&third=this,this,andthis
	function jsearch_parse_vars($vars)
	{
		$to_return = array();
		if (strpos($vars,"&")!==false)
		{
			$pairs = explode("&",$vars);
			foreach($pairs as $a_pair)
				$to_return = array_merge($to_return,jsearch_parse_pair($a_pair));
			return $to_return;
		}
		else
			return jsearch_parse_pair($vars);		// One pair.
	}
	

	// This writes a category with the controls used on the actual Jsearch page. There are four places this works:
	//     The category popup, the list of selected categories that have been added to the search,
	//     The tag popup, and the list of selected categories that have been added to the search.
	// I originally did this in Javascript, but it took WAY too long to respond. Working server-side made it much faster.
	// It also eliminated the need to create two different function for printing categories (one in PHP and one in JS).
	function jsearch_write_control_cattag($which,$cattag,$indent=0)
	{
		global $jsearch_plugin_url;
		static $cattag_count = 0;
		static $first = 1; 			// To save processing
		static $cat_any;			// Series of associative arrays
		static $cat_all;
		static $cat_none;
		static $tag_any;
		static $tag_all;
		static $tag_none;
		
		// If post vars were sent, convert to array and store it in a static var to save processing power
		eval("if (!isset(\$".$which."_any) && strlen(\$_REQUEST['".$which."_any'])) \$".$which."_any = explode(',',\$_REQUEST['".$which."_any']);");
		eval("if (!isset(\$".$which."_all) && strlen(\$_REQUEST['".$which."_all'])) \$".$which."_all = explode(',',\$_REQUEST['".$which."_all']);");
		eval("if (!isset(\$".$which."_none) && strlen(\$_REQUEST['".$which."_none'])) \$".$which."_none = explode(',',\$_REQUEST['".$which."_none']);");
		
		// Now see if we can find this item in one of the three arrays
		eval("if (is_array(\$".$which."_any) && in_array(\$cattag['id'],\$".$which."_any)) \$found = 'any';");
		eval("if (is_array(\$".$which."_all) && in_array(\$cattag['id'],\$".$which."_all)) \$found = 'all';");
		eval("if (is_array(\$".$which."_none) && in_array(\$cattag['id'],\$".$which."_none)) \$found = 'none';");

		$to_write  = "<tr id='jsearch_".$which."_".$cattag['id']."'>";
		$to_write .= "<td style='padding-right:8px'><img src=".$jsearch_plugin_url."/delete_off.gif  onclick=\"jsearchAddCatTag('".$which."','del',".$cattag['id'].")\" class=hand /></td>";
		$to_write .= "<td><img id=jsearch_".$which."_none_".$cattag['id']." src=".$jsearch_plugin_url."/none_".(($found=="none")?"on":"off").".gif onclick=\"jsearchAddCatTag('".$which."','none',".$cattag['id'].")\" class=hand /></td>";
		$to_write .= "<td><img id=jsearch_".$which."_any_".$cattag['id']." src=".$jsearch_plugin_url."/any_".(($found=="any")?"on":"off").".gif  onclick=\"jsearchAddCatTag('".$which."','any',".$cattag['id'].")\" class=hand /></td>";
		$to_write .= "<td><img id=jsearch_".$which."_all_".$cattag['id']." src=".$jsearch_plugin_url."/all_".(($found=="all")?"on":"off").".gif  onclick=\"jsearchAddCatTag('".$which."','all',".$cattag['id'].")\" class=hand /></td>";
		$to_write .= "<td class='jsearch_item_name'><div style='padding-left:".($indent*30)."px'>".$cattag['name']."</div></td>";
		$to_write .= "</tr>";		
		
		$cattag_count++;

		return $to_write;
	}

	// Here's a listing of vars that this function can take in the "var=1&nothervar=something" wordpress format
	//
	// cats = A list of categories to print separated by commas. You can use IDs or names or a combination. If unset, prints all categories
	//      cats=1,3,5     or     cats=georgia,asia,monterey
	// tags = Alternative to cats (mutually exclusive). Use this for a specific list of tags (names or ids, either works)
	//      tags=1,3,5     or     tags=georgia,asia,monterey
	// which = tag or cat. Which are we printing. If you want to print all cats or tags, leave cats and which blank for categories, or which=tag for all tags
	//	which=tag (prints all tags)
	// noindent = turns off subcategory indenting. If unset, indentation occurs
	// 	noindent=1
	// indent_str = the string to print for each indentation level. Defaults to a series of spaces, but can be image or div spacer or anything.
	//	indent_str="<span style='width:50px'></span>"
	// depth = how many subcategory levels to print. If unset, prints all depths
	// 	depth=1
	// filter = A text filter for the categories. Only word matches will show
	//	filter=mis    (matches Missouri or Mississippi or Mistake
	// function = the name of a specific function you wrote to print or write a single category. I'll pass you an array as the only value which holds the category details
	// 	function=myprintfunc            (and in another file somewhere: function myprintfunc(the_cat) {  ... stuff ... }
	function jsearch_print_cattags($vars)
	{
		global $jsearch_cats;
		global $jsearch_tags;
		static $indent = 0;
		static $all_arr = '';

		// The following are static so after the first call, all the modifier vars are still present (depth, print options etc). Now we don't have to pass them in recursive calls
		// They can be overriden by passed values, but otherwise, they'll retain values from the last call
		static $noindent = 0;						// Disable indentation. Can also be done by setting indent_str to nothing
		static $depth = 10;						// How deep to go with categories
		static $exclude = '';						// Holds the cats we've printed so we don't do it again
		static $indent_str = "&nbsp;&nbsp;&nbsp;&nbsp;";		// The string to print when indenting
		static $filter = '';						// A word filter to show only certain categories with selected letter
		static $function = '';						// Holds the name of a user-defined print function to call for special printing uses
					
		if (strlen($vars)) extract(jsearch_parse_vars($vars));		// Parse function makes an associative array. Extract makes them into usable variables
		// Because parse vars makes comma lists into an array, undo it for just this var (easier to manage it as a string)
		if (is_array($exclude))						// This will only ever happen on the first load of the function from the user since I don't use exclude during the function
			$exclude = ",".implode(",,",$exclude).",";		// Creates a string like this ",8,,34,2," so all cats values will have commas before and after

		if (!$which && !$cats && !$tags) $which = "cat";		// Print cats by default
		else if ($cats)	$which = "cat";
		else if ($tags) $which = "tag";
		
		eval("\$cattags = \$".$which."s;");				// Ends up either $cattags = $cats or $cattags = $tags
	
		if ($indent > 0 && !$cattags) return;				// If this is a subcategory call, but there's nothing here, abort
		if (!$cattags && $indent==0 && $which=='cat')
			$cattags = $jsearch_cats;				// If they didn't list the categories on first call (ignore on recursive calls), print all of them
		if (!$cattags && $which=='tag')
			$cattags = $jsearch_tags;

		if (!$all_arr)							// Hasn't been set yet
			if ($all_arr = $_GET[$which."_all"])			// If they passed this in the url, grab it (cat or tag all array)
				$all_arr = explode(",",$all_arr);		// Make it into an array

		if (!is_array($cattags))					// Special case. We need cats to be an array. This should only happen when there's one cat
			$cattags = array($cattags);				// Only one cat. Special case.
		
		if ($cats || $tags)						// They manually specified a list
		{
			$cattags_temp = array();
			eval("\$cats_or_tags = \$jsearch_".$which."s;");	
			
			foreach ($cattags as $cattag_id)
			{
				if (!is_numeric($cattag_id))				// Did they give us the cat name instead of id?
				{
					$name = trim($cattag_id);			// Delete any empty spaces on the outer edges
					foreach ($cats_or_tags as $key => $a_cattag)	// Find it
					{
						if ($a_cattag['name'] == $cattag_id) 	// Found it!
						{
							$cattag_id = $key;		// Change the name for the ID
							break;
						}
					}					
				}
				$cattags_temp[] = $cats_or_tags[$cattag_id];		// Add one of the selected cats to the print array
			}
			$cattags = $cattags_temp;					// Now set up our list of cats for printing in the next for loop
		}
		
		//**********
		// This bit is to handle the situation where they show subcategories of a subcategory. Have to find the highest level indentation for this set
		if ($indent == 0 && !$noindent)						// Only at the top level, and indentaiton isn't turned off;
		{
			$indent = 100;							
			foreach ($cattags as $a_cattag)					// Go through all categories
			{
				if (intval($a_cattag['depth']) < $indent)		// If this indentation level is less than the current...
					$indent = intval($a_cattag['depth']);		// Take on the lowest
			}
		}	
		
		foreach ($cattags as $a_cattag)
		{
			if (strlen($filter) && strpos(strtolower($a_cattag['name']),strtolower($filter)) === false)	// If the filter is set and this cat lacks the requirement, SKIP!
				continue;
			if (strpos($exclude,','.$a_cattag['id'].',') === false)		// It's not in the exclude string
			if ($indent == $a_cattag['depth'])				// And this is the depth it's supposed to be in
			{
				if (!$function)						// Default behavior: checklist
				{	
					// Indent subcats
					if (!$noindent && $indent)
						for ($i=0;$i<$indent;$i++)
							echo $indent_str;
					echo "<input type=checkbox value=".$a_cattag['id'];
					if (is_array($all_arr) && in_array($a_cattag['id'],$all_arr)) echo " checked ";	// It was selected in the search so preserve its setting
					echo " onclick=\" if (this.checked) jsearchValFromTo(this.value,'$which','all'); else jsearchValFromTo(this.value,'$which','del');\" />".$a_cattag['name']."<br/>";
				}
				else
				{
					eval($function."(\$a_cattag,\$vars);");		// calls  "custom_function($category)" (passed the current category value so whatever needs to be written can be
				}
				$exclude .= ','.$a_cattag['id'].',';
			}
			if (strlen($a_cattag['subcats']) && $indent < $depth)
			{
				$temp = explode(',',$a_cattag['subcats']);
				if (!$depth || $indent < $depth)			// When the indent level is the same as the depth, then we've printed the right depth of subcats
				{
					$indent++;
					jsearch_print_cattags("which=".$which."&cats=".$a_cattag['subcats']);
					$indent--;
				}
			}	
		}
	}
	
	// Prints a button that makes the page update category selections from various category controls
	function jsearch_cat_go_button()
	{
		echo "<br/><input class='jsearch_cat_go_button' type=button value=' GO ' onclick=\"document.location.href= jsearchAddVars(jsearchTargetPage,'cat_all='+cat_all)\"/>\n";
	}
?>